{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Edit label data"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {},
   "outputs": [],
   "source": [
    "import pandas as pd \n",
    "\n",
    "def get_data(path):\n",
    "    if path.lower().endswith(\".csv\"):\n",
    "        df = pd.read_csv(path)\n",
    "    elif path.lower().endswith(\".xlsx\"):\n",
    "        df = pd.read_excel(path, sheet_name=\"Sheet1\")\n",
    "    return df"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>text</th>\n",
       "      <th>label</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>0</th>\n",
       "      <td>Hôm nay ngày đẹp trời. Long tâm trạng cực kỳ v...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>1</th>\n",
       "      <td>Long làm việc chiều tối mới về. Không biết sao...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2</th>\n",
       "      <td>– Alo anh yêu à! Em nghe nè! Có chuyện gì khôn...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>3</th>\n",
       "      <td>Long nhớ vợ quá! Mới gọi chút cũng chả đỡ nhớ,...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>4</th>\n",
       "      <td>– Long ngày nào cũng gọi nói nhảm vậy đó hả? –...</td>\n",
       "      <td>khieu_dam</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>...</th>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>12432</th>\n",
       "      <td>– Ahhh!!! Anh chịu hết nổi rồi… Chắc anh ra… m...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>12433</th>\n",
       "      <td>Nói xong nàng gồng người xuất tinh chan chứa. ...</td>\n",
       "      <td>khieu_dam</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>12434</th>\n",
       "      <td>Tôi ghì chặt lấy Hương một lúc lâu cho đến khi...</td>\n",
       "      <td>khieu_dam</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>12435</th>\n",
       "      <td>– Không chịu! Anh nói là xuất tinh cho em thấy...</td>\n",
       "      <td>khieu_dam</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>12436</th>\n",
       "      <td>Nói xong tôi hôn lên môi nàng một lần nữa, rồi...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "<p>12437 rows × 2 columns</p>\n",
       "</div>"
      ],
      "text/plain": [
       "                                                    text      label\n",
       "0      Hôm nay ngày đẹp trời. Long tâm trạng cực kỳ v...       khac\n",
       "1      Long làm việc chiều tối mới về. Không biết sao...       khac\n",
       "2      – Alo anh yêu à! Em nghe nè! Có chuyện gì khôn...       khac\n",
       "3      Long nhớ vợ quá! Mới gọi chút cũng chả đỡ nhớ,...       khac\n",
       "4      – Long ngày nào cũng gọi nói nhảm vậy đó hả? –...  khieu_dam\n",
       "...                                                  ...        ...\n",
       "12432  – Ahhh!!! Anh chịu hết nổi rồi… Chắc anh ra… m...       khac\n",
       "12433  Nói xong nàng gồng người xuất tinh chan chứa. ...  khieu_dam\n",
       "12434  Tôi ghì chặt lấy Hương một lúc lâu cho đến khi...  khieu_dam\n",
       "12435  – Không chịu! Anh nói là xuất tinh cho em thấy...  khieu_dam\n",
       "12436  Nói xong tôi hôn lên môi nàng một lần nữa, rồi...       khac\n",
       "\n",
       "[12437 rows x 2 columns]"
      ]
     },
     "execution_count": 2,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "df = get_data('/home/anhcd/Products/kiem-duyet-noi-dung-van-ban-tieng-viet/data/van_ban_khieu_dam.xlsx')\n",
    "df"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>text</th>\n",
       "      <th>label</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>0</th>\n",
       "      <td>Hôm nay ngày đẹp trời. Long tâm trạng cực kỳ v...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>1</th>\n",
       "      <td>Long làm việc chiều tối mới về. Không biết sao...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2</th>\n",
       "      <td>– Alo anh yêu à! Em nghe nè! Có chuyện gì khôn...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>3</th>\n",
       "      <td>Long nhớ vợ quá! Mới gọi chút cũng chả đỡ nhớ,...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>4</th>\n",
       "      <td>– Long ngày nào cũng gọi nói nhảm vậy đó hả? –...</td>\n",
       "      <td>khieu_dam</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "</div>"
      ],
      "text/plain": [
       "                                                text      label\n",
       "0  Hôm nay ngày đẹp trời. Long tâm trạng cực kỳ v...       khac\n",
       "1  Long làm việc chiều tối mới về. Không biết sao...       khac\n",
       "2  – Alo anh yêu à! Em nghe nè! Có chuyện gì khôn...       khac\n",
       "3  Long nhớ vợ quá! Mới gọi chút cũng chả đỡ nhớ,...       khac\n",
       "4  – Long ngày nào cũng gọi nói nhảm vậy đó hả? –...  khieu_dam"
      ]
     },
     "execution_count": 3,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "df.rename(columns={'content': 'text'}, inplace=True)\n",
    "df.rename(columns={'index_spans': 'label'}, inplace=True)\n",
    "df.head()"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "metadata": {},
   "outputs": [],
   "source": [
    "def process_row(row):\n",
    "    # Kiểm tra xem label có hợp lệ không \n",
    "    if row['label'] == \"phan_cam\":\n",
    "        return \"thu_ghet\"\n",
    "    else:\n",
    "        return row['label']\n",
    "\n",
    "df['label'] = df.apply(process_row, axis=1)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 4,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/html": [
       "<div>\n",
       "<style scoped>\n",
       "    .dataframe tbody tr th:only-of-type {\n",
       "        vertical-align: middle;\n",
       "    }\n",
       "\n",
       "    .dataframe tbody tr th {\n",
       "        vertical-align: top;\n",
       "    }\n",
       "\n",
       "    .dataframe thead th {\n",
       "        text-align: right;\n",
       "    }\n",
       "</style>\n",
       "<table border=\"1\" class=\"dataframe\">\n",
       "  <thead>\n",
       "    <tr style=\"text-align: right;\">\n",
       "      <th></th>\n",
       "      <th>text</th>\n",
       "      <th>label</th>\n",
       "    </tr>\n",
       "  </thead>\n",
       "  <tbody>\n",
       "    <tr>\n",
       "      <th>0</th>\n",
       "      <td>Hôm nay ngày đẹp trời. Long tâm trạng cực kỳ v...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>1</th>\n",
       "      <td>Long làm việc chiều tối mới về. Không biết sao...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>2</th>\n",
       "      <td>– Alo anh yêu à! Em nghe nè! Có chuyện gì khôn...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>3</th>\n",
       "      <td>Long nhớ vợ quá! Mới gọi chút cũng chả đỡ nhớ,...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>4</th>\n",
       "      <td>– Long ngày nào cũng gọi nói nhảm vậy đó hả? –...</td>\n",
       "      <td>khieu_dam</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>...</th>\n",
       "      <td>...</td>\n",
       "      <td>...</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>12432</th>\n",
       "      <td>– Ahhh!!! Anh chịu hết nổi rồi… Chắc anh ra… m...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>12433</th>\n",
       "      <td>Nói xong nàng gồng người xuất tinh chan chứa. ...</td>\n",
       "      <td>khieu_dam</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>12434</th>\n",
       "      <td>Tôi ghì chặt lấy Hương một lúc lâu cho đến khi...</td>\n",
       "      <td>khieu_dam</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>12435</th>\n",
       "      <td>– Không chịu! Anh nói là xuất tinh cho em thấy...</td>\n",
       "      <td>khieu_dam</td>\n",
       "    </tr>\n",
       "    <tr>\n",
       "      <th>12436</th>\n",
       "      <td>Nói xong tôi hôn lên môi nàng một lần nữa, rồi...</td>\n",
       "      <td>khac</td>\n",
       "    </tr>\n",
       "  </tbody>\n",
       "</table>\n",
       "<p>12437 rows × 2 columns</p>\n",
       "</div>"
      ],
      "text/plain": [
       "                                                    text      label\n",
       "0      Hôm nay ngày đẹp trời. Long tâm trạng cực kỳ v...       khac\n",
       "1      Long làm việc chiều tối mới về. Không biết sao...       khac\n",
       "2      – Alo anh yêu à! Em nghe nè! Có chuyện gì khôn...       khac\n",
       "3      Long nhớ vợ quá! Mới gọi chút cũng chả đỡ nhớ,...       khac\n",
       "4      – Long ngày nào cũng gọi nói nhảm vậy đó hả? –...  khieu_dam\n",
       "...                                                  ...        ...\n",
       "12432  – Ahhh!!! Anh chịu hết nổi rồi… Chắc anh ra… m...       khac\n",
       "12433  Nói xong nàng gồng người xuất tinh chan chứa. ...  khieu_dam\n",
       "12434  Tôi ghì chặt lấy Hương một lúc lâu cho đến khi...  khieu_dam\n",
       "12435  – Không chịu! Anh nói là xuất tinh cho em thấy...  khieu_dam\n",
       "12436  Nói xong tôi hôn lên môi nàng một lần nữa, rồi...       khac\n",
       "\n",
       "[12437 rows x 2 columns]"
      ]
     },
     "execution_count": 4,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "df"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 5,
   "metadata": {},
   "outputs": [],
   "source": [
    "df.to_excel(\"/home/anhcd/Products/kiem-duyet-noi-dung-van-ban-tieng-viet/data/van_ban_khieu_dam.xlsx\")"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Append DataFrames (concatenate rows)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {},
   "outputs": [],
   "source": [
    "import pandas as pd \n",
    "\n",
    "def get_data(path):\n",
    "    if path.lower().endswith(\".csv\"):\n",
    "        df = pd.read_csv(path)\n",
    "    elif path.lower().endswith(\".xlsx\"):\n",
    "        df = pd.read_excel(path, sheet_name=\"Sheet1\")\n",
    "    return df"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "metadata": {},
   "outputs": [],
   "source": [
    "df1 = get_data('/home/anhcd/Products/kiem-duyet-noi-dung-van-ban-tieng-viet/data/ngon_tu_phan_cam1.xlsx')\n",
    "df2 = get_data('/home/anhcd/Products/kiem-duyet-noi-dung-van-ban-tieng-viet/data/ngon_tu_phan_cam2.xlsx')"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 7,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "8844"
      ]
     },
     "execution_count": 7,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "len(df1)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 8,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "1106"
      ]
     },
     "execution_count": 8,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "len(df2)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 9,
   "metadata": {},
   "outputs": [],
   "source": [
    "data = [df1, df2]\n",
    "df = pd.concat(data)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 10,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "9950"
      ]
     },
     "execution_count": 10,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "len(df)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 11,
   "metadata": {},
   "outputs": [],
   "source": [
    "df.to_excel(\"/home/anhcd/Products/kiem-duyet-noi-dung-van-ban-tieng-viet/data/ngon_tu_phan_cam_all.xlsx\")"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "bert",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.10.14"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
